#include <stdio.h>
#include <stdlib.h>

int main()
{
    int n,m,i,j;
    scanf("%d %d",&n,&m);
    int niz[n*n];
    int g=n*n;
    for(i=0;i<g;i++){
        scanf("%d",&niz[i]);
    }
    int p,s=0,z;
    for(i=1;i<=m;i++){
        p=0;z=0;
        for(j=0;j<n*n;j++){
            if(niz[j]==i){
                p=1;
                break;
            }
        }
        while(niz[++j]==i && j%n !=0 && p<n){
            p++;
        }
        //printf("%d",p);
        int x=j;
        for(x=j;x<n*n;x++){
            while(x<j+n-p){
                if(niz[++x]==i){
                    z=1;
                    break;
                }
            }
            if(z==1)break;
            int q;
            if(niz[x]==i){
                for(q=1;q<p;q++){
                    if(niz[x++]!=i){
                        z=1;
                        break;
                    }
                }
            }
            else{
                while(x<n*n){
                    if(niz[++x]==i){
                        z=1;
                        break;
                    }
                }
            }
        }
        if(z==1)continue;
        s++;
    }
    printf("%d",s);
}